/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package firealarmjava;

import java.util.ArrayList;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.Short;
import javax.swing.Timer;

/**
 *
 * @author Sebastia
 */
public class Sensor {

    private short nodeId;
    private boolean active;
    private boolean live;
    private boolean fireAlarm;
    private boolean fireAlarmAcked;
    private boolean manualAlarm;
    private boolean batAlarm;
    private boolean allData;
    private String fireDate;
    private String batDate;
    private String deadDate;
    boolean firstTime = true;
    private int tempThd;
    private int tempTimerPeriod;
    private int batTimerPeriod;
    private int debugTimerPeriod;
    private int currentTemp;
    private int currentBatLevel;
    private int currentLight;
    private int vrefmilivolts;
    private ArrayList<SensorMessage> messages = new ArrayList<SensorMessage>();

   
    //Create a new Sensor with identifier nId 
    public Sensor(short nId){
        this.nodeId = nId;
        this.active = false;
        this.live = true;
        this.batAlarm = false;
        this.fireAlarm = false;
        this.allData = false;
    }
    
    
    
	Timer Timer = new Timer (120000, new ActionListener ()
    {
        public void actionPerformed(ActionEvent e)
        {
        	if(live) deadDate = FireAlarmJava.getCurrentTime();
        	live = false;
        	deadNotification(nodeId);
         }
    });
	
	/**
	 * Notifies sensor dead
	 */
	static void deadNotification(short nId){
    	FireAlarmJava.sensorDead(nId);
    }
	
	/**
	 * Ad a message to messages ArrayList
	 * @param msg
	 */
    public void AddMessage(SensorMessage msg){
        getMessages().add(msg);
    }

    /**
     * @return the nodeId
     */
    public short getNodeId() {
        return nodeId;
    }

    /**
     * @param nodeId the nodeId to set
     */
    public void setNodeId(short nodeId) {
        this.nodeId = nodeId;
    }

    /**
     * @return the active
     */
    public boolean isActive() {
        return active;
    }

    /**
     * @param active the active to set
     */
    public void setActive(boolean active) {
        this.active = active;
    }

    /**
     * @return the fireAlarm
     */
    public boolean isFireAlarm() {
        return fireAlarm;
    }

    /**
     * @param fireAlarm the fireAlarm to set
     */
    public void setFireAlarm(boolean fireAlarm) {
        this.fireAlarm = fireAlarm;
    }

    /**
     * @return the batAlarm
     */
    public boolean isBatAlarm() {
        return batAlarm;
    }

    /**
     * @param batAlarm the batAlarm to set
     */
    public void setBatAlarm(boolean batAlarm) {
        this.batAlarm = batAlarm;
    }

    /**
     * @return the tempThd
     */
    public int getTempThd() {
        return tempThd;
    }

    /**
     * @param tempThd the tempThd to set
     */
    public void setTempThd(int tempThd) {
        this.tempThd = tempThd;
    }

    /**
     * @return the tempTimerPeriod
     */
    public int getTempTimerPeriod() {
        return tempTimerPeriod;
    }

    /**
     * @param tempTimerPeriod the tempTimerPeriod to set
     */
    public void setTempTimerPeriod(int tempTimerPeriod) {
        this.tempTimerPeriod = tempTimerPeriod;
    }

    /**
     * @return the batTimerPeriod
     */
    public int getBatTimerPeriod() {
        return batTimerPeriod;
    }

    /**
     * @param batTimerPeriod the batTimerPeriod to set
     */
    public void setBatTimerPeriod(int batTimerPeriod) {
        this.batTimerPeriod = batTimerPeriod;
        Timer.setDelay(3*batTimerPeriod);
    }

    /**
     * @return the debugTimerPeriod
     */
    public int getDebugTimerPeriod() {
        return debugTimerPeriod;
    }

    /**
     * @param debugTimerPeriod the debugTimerPeriod to set
     */
    public void setDebugTimerPeriod(int dataTimerPeriod) {
        this.debugTimerPeriod = dataTimerPeriod;
    }

    /**
     * @return the currentTemp
     */
    public int getCurrentTemp() {
        return currentTemp;
    }

    /**
     * @param currentTemp the currentTemp to set
     */
    public void setCurrentTemp(int currentTemp) {
        this.currentTemp = currentTemp;
    }

    /**
     * @return the currentBatLevel
     */
    public int getCurrentBatLevel() {
        return currentBatLevel;
    }

    /**
     * @param currentBatLevel the currentBatLevel to set
     */
    public void setCurrentBatLevel(int currentBatLevel) {
        this.currentBatLevel = currentBatLevel;	
		if(firstTime){
    		Timer.start();
    		firstTime = false;
    	}
    	else Timer.restart();
    }

    /**
     * @return the currentLight
     */
    public int getCurrentLight() {
        return currentLight;
    }

    /**
     * @param currentLight the currentLight to set
     */
    public void setCurrentLight(int currentLight) {
        this.currentLight = currentLight;
    }

    /**
     * @return the messages
     */
    public ArrayList<SensorMessage> getMessages() {
        return messages;
    }
    
    /**
     * Overwrite equals()
     * @param sens
     * @return
     */
    public boolean equals(Sensor sens){
    	Short sensId = sens.getNodeId();
    	if (sensId.equals((Short)this.getNodeId())) return true;
        else return false;
    }
    
    /**
     * Overwrite toString()
     * @param sens
     * @return
     */
    public String toString(){
    	return "" + nodeId;
    }

    /**
     * @return the manualAlarm
     */
    public boolean isManualAlarm() {
        return manualAlarm;
    }

    /**
     * @param manualAlarm the manualAlarm to set
     */
    public void setManualAlarm(boolean manualAlarm) {
        this.manualAlarm = manualAlarm;
    }

    /**
     * @return the vrefmilivolts
     */
    public int getVref() {
        return vrefmilivolts;
    }

    /**
     * @param vrefmilivolts the vrefmilivolts to set
     */
    public void setVref(int vrefmilivolts) {
        this.vrefmilivolts = vrefmilivolts;
    }

	/**
	 * @param fireAlarmAcked the fireAlarmAcked to set
	 */
	public void setFireAlarmAcked(boolean fireAlarmAcked) {
		this.fireAlarmAcked = fireAlarmAcked;
	}

	/**
	 * @return the fireAlarmAcked
	 */
	public boolean isFireAlarmAcked() {
		return fireAlarmAcked;
	}

	/**
	 * @param allData the allData to set
	 */
	public void setAllData(boolean allData) {
		this.allData = allData;
	}

	/**
	 * @return the allData
	 */
	public boolean isAllData() {
		return allData;
	}

	/**
	 * @param live the live to set
	 */
	public void setLive(boolean live) {
		this.live = live;
	}

	/**
	 * @return the live
	 */
	public boolean isLive() {
		return live;
	}

	/**
	 * @param fireDate the fireDate to set
	 */
	public void setFireDate(String fireDate) {
		this.fireDate = fireDate;
	}

	/**
	 * @return the fireDate
	 */
	public String getFireDate() {
		return fireDate;
	}

	/**
	 * @param batDate the batDate to set
	 */
	public void setBatDate(String batDate) {
		this.batDate = batDate;
	}

	/**
	 * @return the batDate
	 */
	public String getBatDate() {
		return batDate;
	}

	/**
	 * @param deadDate the deadDate to set
	 */
	public void setDeadDate(String deadDate) {
		this.deadDate = deadDate;
	}

	/**
	 * @return the deadDate
	 */
	public String getDeadDate() {
		return deadDate;
	}
	

}
